package com.timothyveletta;

import java.util.ArrayList;

public class StateMachine {
	FuzzyBot object;
	ArrayList<State> states = new ArrayList<State>();
	
	StateMachine(FuzzyBot obj) { object = obj; }
	
	public void Init() {
		for(int i = 0; i < states.size(); i++) {
			states.get(i).Init();
		}
	}
	
	public void UpdateMachine() {
		for(int i = 0; i < states.size(); ++i) {
			states.get(i).Update();
		}
	}
	
	public void AddState(State st) {
		states.add(st);
	}
	
	public double ActivationLevel(State st) {
		int index = states.indexOf(st);
		
		return states.get(index).activationLevel;
	}
}
