package kc.mega.learning;

public class GFBins {
  public final int nBins;
  public final double binWidth;
  public final double[] lowerGF;
  public final double[] upperGF;
  public final double[] midPoint;

  public GFBins(int nBins) {
    this.nBins = nBins;
    binWidth = 2.0 / nBins;
    lowerGF = new double[nBins];
    upperGF = new double[nBins];
    midPoint = new double[nBins];
    for (int i = 0; i < nBins; i++) {
      lowerGF[i] = (i * binWidth) - 1;
      upperGF[i] = ((i + 1) * binWidth) - 1;
      midPoint[i] = ((i + 0.5) * binWidth) - 1;
    }
  }

  public int hitBin(double GF) {
    return (int)Math.round(((GF + 1) / binWidth) - 0.5);
  }

  public double binWeight(double[] GFRange, int bin) {
    double lowPoint = Math.max(lowerGF[bin], GFRange[0]);
    double highPoint = Math.min(upperGF[bin], GFRange[1]);
    return Math.max(0, highPoint - lowPoint) / binWidth;
  }
}
